<template>
  <div class="font-sans antialiased bg-gray-100 dark:bg-gray-800 text-gray-700 dark:text-gray-300">
    <div class="h-screen w-screen relative overflow-hidden">
      <router-view
        class="router-view p-5 pb-12 sm:p-20 h-full w-full"
        v-slot="{ Component }"
      >
        <transition :name="$data.transition">
          <component :is="Component" :key="$route.path" />
        </transition>
      </router-view>
    </div>
    <footer class="absolute w-screen bottom-0 text-right pr-4 pb-4">
      © 2022 Sascha Hemleb
      |
      <button @click="switchTheme">switch theme</button>
    </footer>
  </div>
</template>

<script lang="ts">
import { defineComponent } from "vue";

interface AppData {
  transition: string
}

export default defineComponent({
  data(): AppData {
    return {
      transition: <string|undefined>this.$route.meta.transition || '',
    }
  },
  watch: {
    '$route'() {
      this.$data.transition = <string|undefined>this.$route.meta.transition || '';
    }
  },
  methods: {
    switchTheme() {
      document.documentElement.classList.toggle('dark')
    }
  },
  mounted() {
    document.documentElement.classList.toggle('dark', window.matchMedia('(prefers-color-scheme: dark)').matches)
  }
});
</script>

<style>
footer {
  mix-blend-mode: difference;
}
</style>
